/* ========================================================================== */
/* == UPMC/master/info/4I506 -- Janvier 2016/2017/2018                     == */
/* == SU/FSI/master/info/MU4IN503 -- Janvier 2020/2021/2022                == */
/* == Analyse des programmes et sémantiques                                == */
/* ========================================================================== */
/* == hello-APS Syntaxe C                                                  == */
/* == Fichier: ast.c                                                       == */
/* ==  Arbre de syntaxe abstraite                                          == */
/* ========================================================================== */
#include <stdlib.h>
#include <stdio.h>
#include "ast.h"

Expr newASTNum(int v) {
  Expr r = mallocExpr;
  r->tag = ASTNum;
  r->content.num = v;
  return r;
}

Expr newASTId(char* v) {
  Expr r = mallocExpr;
  r->tag = ASTId;
  r->content.id = v;
  return r;
}

Expr newASTApp(Expr e, Exprs es) {
  Expr r = mallocExpr;
  r->tag = ASTApp;
  r->content.app.fun = e;
  r->content.app.args = es;
  return r;
}

Exprs addExpr(Expr e, Exprs es) {
  Exprs r = mallocExprs;
  r->head = e;
  r->tail = es;
  return r;
}

Stat newASTEcho(Expr e) {
  Stat r = mallocStat;
  r->tag = ASTecho;
  r->content.expr = e;
  return r;
}

Cmd newStat(Stat s) {
  Cmd r = mallocCmd;
  r->tag = ASTstat;
  r->content.stat = s;
  return r;
}

Cmds addStat(Stat s, Cmds cs) {
  Cmds r = mallocCmds;
  r->head = newStat(s);
  r->tail = cs;
  return r;
}



