/* ========================================================================== */
/* == UPMC/master/info/4I506 -- Janvier 2016/2017/2018                     == */
/* == SU/FSI/master/info/MU4IN503 -- Janvier 2020/2021/2022                == */
/* == Analyse des programmes et sémantiques                                == */
/* ========================================================================== */
/* == hello-APS Syntaxe C                                                  == */
/* == Fichier: ast.h                                                       == */
/* ==  Arbre de syntaxe abstraite                                          == */
/* ========================================================================== */

/* Expressions et suites d'expressions */
typedef struct _expr *Expr;
typedef struct _exprs *Exprs;

enum expr_tag {
  ASTNum, ASTId, ASTApp 
};

struct _expr {
  enum expr_tag tag;
  union {
    int num;
    char* id;
    struct {
      Expr fun;
      Exprs args;
    } app;
  } content;
};

#define mallocExpr malloc(sizeof(struct _expr))

Expr newASTNum(int n);
Expr newASTId(char* x);
Expr newASTApp(Expr e, Exprs es);

#define getNum(e) e->content.num
#define getId(e) e->content.id
#define getFun(e) e->content.app.fun
#define getArgs(e) e->content.app.args

struct _exprs {
  Expr head;
  Exprs tail;
};

#define mallocExprs malloc(sizeof(struct _exprs))

Exprs addExpr(Expr e, Exprs es);

/* Instructions */
typedef struct _stat *Stat;

enum stat_tag {
  ASTecho
};

struct _stat {
  enum stat_tag tag;
  union {
    Expr expr;
  } content;
};

#define mallocStat malloc(sizeof(struct _stat))

Stat newASTEcho(Expr e);

#define getExpr(x) x->content.expr

/* Commandes et suites de commandes */
typedef struct _cmd *Cmd;

enum cmd_tag {
  ASTstat
};

struct _cmd {
  enum cmd_tag tag;
  union {
    Stat stat;
  } content;
};
  
#define mallocCmd malloc(sizeof(struct _cmd))

Cmd newStat(Stat s);

#define getStat(c) c->content.stat

typedef struct _cmds *Cmds;

struct _cmds {
  Cmd head;
  Cmds tail;
};

#define mallocCmds malloc(sizeof(struct _cmds))

Cmds addStat(Stat s, Cmds cs);

/* Programme */
typedef struct _cmds *Prog;




