/* ========================================================================== */
/* == UPMC/master/info/4I506 -- Janvier 2016/2017/2018                     == */
/* == SU/FSI/master/info/MU4IN503 -- Janvier 2020/2021/2022                == */
/* == Analyse des programmes et sémantiques                                == */
/* ========================================================================== */
/* == hello-APS Syntaxe C                                                  == */
/* == Fichier: prologTerm.c                                                == */
/* == Génération du terme prolog                                           == */
/* ========================================================================== */

#include <stdio.h>
#include "ast.h"
#include "prologTerm.h"

void printExprs(Exprs);

void printExpr(Expr e) {
  switch(e->tag) {
  case ASTNum : printf("num(%d)",getNum(e)); break;
  case ASTId : printf("id(%s)",getId(e)); break;
  case ASTApp : {
    printf("app(");
    printExpr(getFun(e));
    printf(",[");
    printExprs(getArgs(e));
    printf("])");
    break;
  }
  }
}

void printExprs(Exprs es) {
  if (es) {
    while (es->tail) {
      printExpr(es->head);
      printf(",");
      es = es->tail;
    };
    printExpr(es->head);
  }
}

void printStat(Stat s) {
  switch(s->tag) {
  case ASTecho : {
    printf("echo(");
    printExpr(getExpr(s));
    printf(")");
    break;
  }
  }
}

void printCmd(Cmd c) {
  switch(c->tag) {
  case ASTstat : printStat(getStat(c)); break;
  }
}
  
void printCmds(Cmds cs) {
  printf("[");
  while (cs->tail) {
    printCmd(cs->head);
    printf(",");
    cs = cs->tail;
  }
  printCmd(cs->head);
  printf("]");
}

void printProg(Prog cs) {
  if (cs) {
    printf("prog(");
    printCmds(cs);
    printf(")");
  }
}
